// -*- c++ -*-
// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!
#ifndef _GOOCANVASMM_TABLE_H
#define _GOOCANVASMM_TABLE_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <goocanvasmm/group.h>
#include <gtkmm/enums.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GooCanvasTable GooCanvasTable;
typedef struct _GooCanvasTableClass GooCanvasTableClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Goocanvas
{ class Table_Class; } // namespace Goocanvas
#endif //DOXYGEN_SHOULD_SKIP_THIS

namespace Goocanvas
{


class Table : public Goocanvas::Group
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Table CppObjectType;
  typedef Table_Class CppClassType;
  typedef GooCanvasTable BaseObjectType;
  typedef GooCanvasTableClass BaseClassType;

  // noncopyable
  Table(const Table&) = delete;
  Table& operator=(const Table&) = delete;

private:  friend class Table_Class;
  static CppClassType table_class_;

protected:
  explicit Table(const Glib::ConstructParams& construct_params);
  explicit Table(GooCanvasTable* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  Table(Table&& src) noexcept;
  Table& operator=(Table&& src) noexcept;

  virtual ~Table() noexcept;

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GooCanvasTable*       gobj()       { return reinterpret_cast<GooCanvasTable*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GooCanvasTable* gobj() const { return reinterpret_cast<GooCanvasTable*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GooCanvasTable* gobj_copy();

private:

protected:
  Table();
  

public:

  
  static Glib::RefPtr<Table> create();


  /** This convenience method is easier than setting the properties individually,
   * and is similar to Gtk::Table::attach().
   *
   * @param item The canvas item to add to the table.
   * @param left_attach The left column to attach the item.
   * @param right_attach The right column to attach the item. Just use left_attach+1 for a single column.
   * @param top_attach The top column to attach the item.
   * @param bottom_attach The bottom column to attach the item. Just use top_attach+1 for a single column.
   * @param xoptions Whether the item should expand or shrink.
   * @param yoptions Whether the item should expand or shrink.
   * @param left_padding The padding at the left.
   * @param right_padding The padding at the right.
   * @param top_padding The padding at the top.
   * @param bottom_padding The padding at the bottom.
   */
  void attach(const Glib::RefPtr<Item>& item, guint left_attach, guint right_attach, guint top_attach, guint bottom_attach, Gtk::AttachOptions xoptions = Gtk::FILL | Gtk::EXPAND, Gtk::AttachOptions yoptions = Gtk::FILL | Gtk::EXPAND, double left_padding = 0.0, double right_padding = 0.0, double top_padding = 0.0, double bottom_padding = 0.0);

  // TODO: We should get rid of this overload with the next gtkmm API/ABI break.
  // See http://bugzilla.gnome.org/show_bug.cgi?id=142849.
  void set_align(const Glib::RefPtr<Item>& child, double xalign = 0.0, double yalign = 0.0);
  void set_align(const Glib::RefPtr<Item>& child, Gtk::Align xalign = Gtk::ALIGN_START, Gtk::Align yalign = Gtk::ALIGN_START);

  //We put these in item.hg instead.
  //See the comment there.
  //_WRAP_PROPERTY("x", double)
  //_WRAP_PROPERTY("y", double)
  //_WRAP_PROPERTY("width", double)
  //_WRAP_PROPERTY("height", double)
  /** The default space between rows.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_row_spacing() ;

/** The default space between rows.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_row_spacing() const;

  /** The default space between columns.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_column_spacing() ;

/** The default space between columns.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_column_spacing() const;

  /** If all rows are the same height.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< bool > property_homogeneous_rows() ;

/** If all rows are the same height.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< bool > property_homogeneous_rows() const;

  /** If all columns are the same width.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< bool > property_homogeneous_columns() ;

/** If all columns are the same width.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< bool > property_homogeneous_columns() const;

  /** The amount of spacing between the lefmost and rightmost cells and the border grid line.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_x_border_spacing() ;

/** The amount of spacing between the lefmost and rightmost cells and the border grid line.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_x_border_spacing() const;

  /** The amount of spacing between the topmost and bottommost cells and the border grid line.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_y_border_spacing() ;

/** The amount of spacing between the topmost and bottommost cells and the border grid line.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_y_border_spacing() const;

  /** The width of the grid line to draw between columns.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_vert_grid_line_width() ;

/** The width of the grid line to draw between columns.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_vert_grid_line_width() const;

  /** The width of the grid line to draw between rows.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_horz_grid_line_width() ;

/** The width of the grid line to draw between rows.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_horz_grid_line_width() const;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} //namespace Goocanvas


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Goocanvas::Table
   */
  Glib::RefPtr<Goocanvas::Table> wrap(GooCanvasTable* object, bool take_copy = false);
}


#endif /* _GOOCANVASMM_TABLE_H */

